LeetCode – Most Frequent Subtree Sum (Java)

Given the root of a tree, you are asked to find the most frequent subtree sum. The subtree sum of a node is defined as the sum of all the node values formed by the subtree rooted at that node (including the node itself). So what is the most frequent subtree sum value? If there is a tie, return all the values with the highest frequency in any order.

Examples 1
Input:

5
/ \
2 -3

return [2, -3, 4], since all the values happen only once, return all of them in any order.

Examples 2
Input:

5
/ \
2 -5

return [2], since 2 happens twice, however -5 only occur once.

Java Solution

We can solve this problem using a typical recursion on the tree, similar to LCA.

public int[] findFrequentTreeSum(TreeNode root) {
    HashMap<Integer,Integer> map = new HashMap<>();
 
    helper(root, map);
 
    int maxCount = 0;
    for(int i: map.keySet()){
        if(map.get(i)>maxCount){
            maxCount=map.get(i);
        }
    }
 
    List<Integer> mf = new ArrayList<>();
    for(Map.Entry<Integer, Integer> entry: map.entrySet()){
        if(entry.getValue()==maxCount){
            mf.add(entry.getKey());
        }
    }
 
    int[] result = new int[mf.size()];
    int k=0;
    for(int i: mf){
        result[k++]=i;
    }
 
    return result;
}
 
public Integer helper(TreeNode root, HashMap<Integer,Integer> map){
    if(root==null){
        return null;
    }
 
    Integer left = helper(root.left, map);
    if(left==null){
        left=0;
    }
 
    Integer right = helper(root.right, map);
    if(right==null){
        right=0;
    }
 
    int sum = root.val + left + right;
    map.put(sum, map.getOrDefault(sum, 0)+1);
 
    return sum;
}

Leave a Comment